﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.Shapes;
using Telerik.WinControls.UI;

namespace _1148246
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();
            new Telerik.WinControls.RadControlSpy.RadControlSpyForm().Show();

            radDiagram1.SelectionMode = Telerik.Windows.Diagrams.Core.SelectionMode.None;
            radDiagram1.IsEditable = false;

            //add the lines
            int Xpos = 200;
            for (int i = 0; i < 4; i++)
            {
                LineShape shape1 = new LineShape()
                {
                    ElementShape = new LinePath(),
                    BackColor = Color.Blue
                };
                shape1.Label.Text = "Line " + i;

                shape1.Size = new Size(50, 500);
                shape1.Position = new Telerik.Windows.Diagrams.Core.Point(Xpos, 20);
                Xpos += 200;
                radDiagram1.Items.Add(shape1);
            }


            RadDiagramShape shape2 = new RadDiagramShape()
            {
                Text = "Test 1",
                ElementShape = new RoundRectShape(5),
                BackColor = Color.Cyan
            };
            shape2.Position = new Telerik.Windows.Diagrams.Core.Point(10, 100);
            radDiagram1.Items.Add(shape2);

            RadDiagramShape shape3 = new RadDiagramShape()
            {


                BackColor = Color.Yellow
            };

            var shape = new PathElementShape();
            //the arrow shape copied from diagram 
            shape.AsString = "0,1,1,1,1,1,129@25,0.5,25,10.5,111.5,10.5,111.5,30.5,25,30.5,25,39.5,0.5,20.5";
            TransformShape(shape, shape3);
            shape3.Position = new Telerik.Windows.Diagrams.Core.Point(110, 150);     
            shape3.AngleTransform = 180;
            shape3.Width = 90;
            shape3.Height = 30;
            radDiagram1.Items.Add(shape3);
        }

        public void TransformShape(PathElementShape shape, RadDiagramShape dShape)
        {
            var grPath = (System.Drawing.Drawing2D.GraphicsPath)shape.Path.Clone();
            var boundsFromPath = grPath.GetBounds();
            dShape.Width = boundsFromPath.Width;
            dShape.Height = boundsFromPath.Height;

            using (System.Drawing.Drawing2D.Matrix m = new System.Drawing.Drawing2D.Matrix())
            {
                m.Scale((float)(dShape.Width / boundsFromPath.Width), (float)(dShape.Height / boundsFromPath.Height));
                grPath.Transform(m);
            }
            dShape.ElementShape = new PathElementShape(grPath, dShape);
        }
    }
    class LineShape : RadDiagramShape
    {
        RadLabelElement label = new RadLabelElement();


        public RadLabelElement Label
        {
            get
            {
                return label;
            }
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();
            label.AngleTransform = 300;
            this.Children.Add(Label);
            this.DiagramShapeElement.DrawText = false;

        }

    }
    class LinePath : ElementShape
    {
        public override GraphicsPath CreatePath(Rectangle bounds)
        {
            var path = new GraphicsPath();

            path.AddRectangle(new RectangleF(bounds.X, bounds.Y + 50, 5, bounds.Height - 50));

            return path;
        }
    }

}
